=== debian/changelog ===
libreswan (3.20-1) UNRELEASED; urgency=low

  * Release 3.20-1

 -- Unknown User <unknown@libreswan.org>  Tue, 14 Mar 2017 01:00:00 +0200
