=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
 https://download.libreswan.org/libreswan-(.+)\.tar\.gz
